package com.demo.scan;

import java.util.ArrayList;
import java.util.List;

import android.graphics.Color;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.text.method.ScrollingMovementMethod;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.ListView;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.ScrollView;
import android.widget.TextView;
import android.widget.Toast;

import com.zltd.decoder.Constants;
import com.demo.scan.R;
/***
 * ɨdemo
 * 
 * @author jan
 * 
 */
public class ScanTestActivity extends BaseScanActivity implements
		OnCheckedChangeListener,
		android.widget.RadioGroup.OnCheckedChangeListener {
	private static final String LOG_TAG = "ScanTestActivity";
	private ScrollView mScrollView;
	private TextView mTextView;
	private CheckBox mWhiteLightCheckBox;
	private CheckBox mRedLightCheckBox;
	private CheckBox mLocationLightCheckBox;
	private CheckBox mDecodeMode;
	private Button mSingleBtn;
	private Button mContinueBtn;
	private RadioGroup mTypeGroup;
	private RadioButton mSingleRB, mContinueRB, mHoldRB;

	protected static final int UPDATE_LIST = 0x1000;
	protected static final int INIT_CONNECT = 0x2000;
	protected static final int ENABLE_WHITE_LIGHT = 0x2002;
	protected static final int ENABLE_RED_LIGHT = 0x2003;
	protected static final int ENABLE_LOCATION_LIGHT = 0x2004;
	protected static final int CONTINUOUS_SHOOT = 0x2005;
	protected static final int SINGLE_SHOOT = 0x2006;
	protected static final int SHOOT_AND_DECODE = 0x2007;
	protected static final int UPDATE_TEXTVIEW = 0x2008;
	protected static final int SCANNER_RESULT_CHANAGE = 0x2009;
	protected static final int OPEN_CAMERA = 0x2010;

	private boolean mContinue;
	private Utils mUtils;
	private Handler mTextHandler = new Handler();

	protected ArrayList<String> mBarcodeList = new ArrayList<String>();
	protected ArrayAdapter<String> mListAdaper;
	private ListView mListView;

	private long lastPressTime;
	private int mPressType = 0;// 0Ϊ1Ϊ
	/**
	 * scanmode=0:ɨ =1:ɨ =2:
	 */
	private int scanMode = Constants.SINGLE_SHOOT_MODE;
	private ScorllTask mTask;
	private boolean isSingleScanning = false;
	private long mStartTime;
	private long mEndTime;
	private long mElapsedTime;
	private TextView mNum;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		Log.d(LOG_TAG, "--------onCreate------");
		setContentView(R.layout.activity_bar_code_test);
		mScrollView = (ScrollView) findViewById(R.id.scrollview);
		mSingleBtn = (Button) findViewById(R.id.single_button);
		mContinueBtn = (Button) findViewById(R.id.continuous_button);
		mTextView = (TextView) findViewById(R.id.text_view);
		mTextView.setMovementMethod(ScrollingMovementMethod.getInstance());
		// CheckBox
		mWhiteLightCheckBox = (CheckBox) findViewById(R.id.white_light_checkBox);
		mWhiteLightCheckBox.setVisibility(8);
		mWhiteLightCheckBox.setOnCheckedChangeListener(this);
		mWhiteLightCheckBox.setVisibility(8);
		mRedLightCheckBox = (CheckBox) findViewById(R.id.red_light_checkBox);
		mRedLightCheckBox.setVisibility(8);
		mRedLightCheckBox.setOnCheckedChangeListener(this);
		mLocationLightCheckBox = (CheckBox) findViewById(R.id.location_light_checkBox);
		mLocationLightCheckBox.setVisibility(8);
		mLocationLightCheckBox.setOnCheckedChangeListener(this);
		mDecodeMode = (CheckBox) findViewById(R.id.decode_mode);
		mDecodeMode.setVisibility(8);
		mDecodeMode.setOnCheckedChangeListener(this);

		mTypeGroup = (RadioGroup) findViewById(R.id.scan_type_group);
		mTypeGroup.setOnCheckedChangeListener(this);
		mSingleRB = (RadioButton) findViewById(R.id.single_type_rb);
		mSingleRB.setChecked(true);
		mContinue = false;
		mUtils = Utils.getInstance();
		mUtils.init(this);
		mListView = (ListView) findViewById(R.id.list);
		mListAdaper = new ArrayAdapter<String>(this, R.layout.list_item,
				mBarcodeList);
		mListView.setAdapter(mListAdaper);
		mListView.setVisibility(View.GONE);
		mTask = new ScorllTask();

		mNum = (TextView) findViewById(R.id.num);
		mNum.setText("0");
	}

	public void onResume() {
		super.onResume();
		scroll2Bottom(mTask);
	}

	public void onPause() {
		super.onPause();
		if (mDecoderMgr.getScanMode() == Constants.SINGLE_SHOOT_MODE
				&& isSingleScanning) {
			isSingleScanning = false;
		}
		mTextHandler.removeCallbacks(mTask);
	}

	public void onDestroy() {
		super.onDestroy();
	}

	// ɨ¼
	public void singleShootOnClick(View view) {
		mStartTime = System.currentTimeMillis();
		// Ϊɨģʽ
		scanMode = 0;
		mDecoderMgr.setScanMode(scanMode);
		if (System.currentTimeMillis() - lastPressTime <= 500) {
			return;
		}
		mPressType = 0;
		if (!isSingleScanning) {
			Log.d(LOG_TAG, "------ɨǰ------");
			mSingleBtn.setTextColor(Color.RED);
			mContinueBtn.setTextColor(Color.BLACK);
			mContinue = false;
			mTextView.append("ɨ...\n");
			lastPressTime = System.currentTimeMillis();
			// ɨ
			mDecoderMgr.singleShoot();
			isSingleScanning = true;
		}
	}

	// ɨ
	public void continuousShootOnClick(View view) {
		// Ϊɨģʽ
		mDecoderMgr.setScanMode(Constants.CONTINUOUS_SHOOT_MODE);
		mPressType = 1;
		mStartTime = System.currentTimeMillis();
		// if (view != null) {
		mSingleBtn.setTextColor(Color.BLACK);
		mContinueBtn.setTextColor(Color.RED);
		// }

		if (mContinue) {
			// رɨ
			mDecoderMgr.stopContinuousShoot();
			mContinue = false;
			mSingleBtn.setClickable(true);
			mContinueBtn.setTextColor(Color.BLACK);
		} else {
			mSingleBtn.setClickable(false);
			mTextView.append("ɨ...\n");
			mContinue = true;
			// ɨĵ
			mDecoderMgr.continuousShoot();
		}
	}

	// ˳
	public void exitOnClick(View view) {
		mSingleBtn.setTextColor(Color.BLACK);
		mContinueBtn.setTextColor(Color.BLACK);
		mTextView.append(" ˳");
		isSingleScanning = false;
		finish();
	}

	public void clearOnClick(View view) {
		if (!isSingleScanning && mPressType != 0) {
			mSingleBtn.setTextColor(Color.BLACK);
		}
		if (!mContinue) {
			mContinueBtn.setTextColor(Color.BLACK);
		}
		mTextView.setText("");
		mBarcodeList.clear();
		mTextView.scrollTo(0, -10);
		mListAdaper.notifyDataSetChanged();
	}

	public void selectTimeOnClick(View view) {

	}

	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		try {
			/**
			 * ڰɨʱ,ǰscanmode=2[ģʽ],mDecoderMgr.
			 * dispatchScanKeyEvent(event); Ӧ,onKeyUpҲҪͬ.
			 */
			if (mDecoderMgr.getScanMode() == 2 && keyCode == 96
					&& event.getRepeatCount() == 0) {
				mStartTime = System.currentTimeMillis();
				Log.d(LOG_TAG, "------startTime=" + mStartTime);
				mDecoderMgr.dispatchScanKeyEvent(event);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return super.onKeyDown(keyCode, event);
	}

	/**
	 * οonKeyDownʵ
	 */
	@Override
	public boolean onKeyUp(int keyCode, KeyEvent event) {
		if (mDecoderMgr.getScanMode() == 2 && keyCode == 96
				&& event.getRepeatCount() == 0) {
			mSingleBtn.setTextColor(Color.BLACK);
			mContinueBtn.setTextColor(Color.BLACK);
			mDecoderMgr.dispatchScanKeyEvent(event);
		}
		return super.onKeyUp(keyCode, event);
	}

	private Handler mHandler = new Handler() {
		public void handleMessage(Message msg) {
			switch (msg.what) {
			case UPDATE_TEXTVIEW:
				String data = (String) msg.obj;
				updateUi(data);
				break;
			case SCANNER_RESULT_CHANAGE:
				String data1 = (String) msg.obj;
				updateUi(data1);
				break;
			}
		}
	};
	private List<String> bars = new ArrayList<String>();

	public void updateUi(String data) {
		// if (mTextView.getLineCount() > 100) {
		// mTextView.setText("");
		// }
		// mTextView.append("ʱ " + mElapsedTime + " MS.\n:");
		if (bars.contains(data)) {
			Toast.makeText(ScanTestActivity.this, "ظɨ", Toast.LENGTH_SHORT)
					.show();
			return;
		}

		if (!isScanTimeOut && data.length() > 0) {
			mTextView.append("\n" + data + "\n");
			bars.add(data);
			int nums = Integer.valueOf(mNum.getText().toString());
			nums = nums + 1;
			mNum.setText(nums+"");
 		} else {
			// mTextView.append("ʱδȡ");
			Toast.makeText(ScanTestActivity.this, "ʱ", Toast.LENGTH_SHORT)
					.show();
		}
		mTextView.append("\n\n");
		mUtils.playSound(Utils.SOUND_TYPE_BEEP);

	}

	@Override
	public void onCheckedChanged(CompoundButton arg0, boolean arg1) {
	}

	/**
	 * պʹɨĽ
	 * 
	 * @param result
	 *            صɨ
	 * @param time
	 *            ĵʱ
	 * 
	 */
	@Override
	public void onDecoderResultChanage(String result, String time) {
		super.onDecoderResultChanage(result, time);
		isScanTimeOut = false;
		mEndTime = System.currentTimeMillis();
		mElapsedTime = mEndTime - mStartTime;
		Log.d(LOG_TAG, "---mElapsedTime=" + mElapsedTime);
		if (result.startsWith("Decode is interruptted")) {
			isScanTimeOut = true;
			Message msg = mHandler.obtainMessage(UPDATE_TEXTVIEW);
			msg.obj = "";
			mHandler.sendMessage(msg);
		} else {
			isScanTimeOut = false;
			Message msg = mHandler.obtainMessage(UPDATE_TEXTVIEW);
			msg.obj = result;
			mHandler.sendMessage(msg);
		}
		if (mPressType == 0 && isSingleScanning) {
			isSingleScanning = false;
		}
		if (mContinue) {
			mStartTime = System.currentTimeMillis();
		}
	}

	@Override
	public void onDecoderStatusChanage(int arg0) {
		super.onDecoderStatusChanage(arg0);
	}

	public void updateList(String data) {
		Log.d(LOG_TAG, "liubo updateList data " + data);
		mBarcodeList.add(0, data);
		mListAdaper.notifyDataSetChanged();
	}

	@Override
	public boolean dispatchKeyEvent(KeyEvent event) {
		Log.d(LOG_TAG, "event.keycode=" + event.getKeyCode());
		if (event.getKeyCode() == KeyEvent.KEYCODE_BUTTON_A
				&& event.getAction() == KeyEvent.ACTION_DOWN
				&& event.getRepeatCount() == 0) {
			if (scanMode == 0) {
				singleShootOnClick(null);
				return true;
			} else if (scanMode == 1) {
				continuousShootOnClick(null);
				return true;
			}
		}
		return super.dispatchKeyEvent(event);
	}

	private class ScorllTask implements Runnable {
		@Override
		public void run() {
			mTextHandler.postDelayed(this, 100);
			if (mScrollView == null || mTextView == null) {
				return;
			}
			int offset = mTextView.getMeasuredHeight()
					- mScrollView.getMeasuredHeight();
			// Log.i(LOG_TAG, "ScorllTask->offset=" + offset);
			if (offset < 0) {
				offset = 0;
			}
			mScrollView.scrollTo(0, offset);
		}
	}

	public void scroll2Bottom(Runnable task) {
		mTextHandler.post(task);
	}

	@Override
	public void onCheckedChanged(RadioGroup group, int checkedId) {
		if (checkedId == R.id.single_type_rb) {
			scanMode = 0;
			mSingleBtn.setEnabled(true);
			mContinueBtn.setEnabled(false);
			mSingleBtn.setClickable(true);
		} else if (checkedId == R.id.continue_type_rb) {
			scanMode = 1;
			mSingleBtn.setEnabled(false);
			mContinueBtn.setEnabled(true);
		} else if (checkedId == R.id.hold_shoot_type_rb) {
			mSingleBtn.setEnabled(false);
			mContinueBtn.setEnabled(false);
			scanMode = 2;
		}
		if (mDecoderMgr.isContinuousShootState()) {
			mDecoderMgr.stopContinuousShoot();
		} else {
			mDecoderMgr.stopShootImmediately();
		}
		mDecoderMgr.setScanMode(scanMode);
		mSingleBtn.setTextColor(Color.BLACK);
		mContinueBtn.setTextColor(Color.BLACK);
	}
}
