package com.demo.scan;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.Window;
import android.view.WindowManager;

import com.zltd.decoder.Constants;
import com.zltd.decoder.DecoderManager;
import com.demo.scan.R;
/**
 * ɨdemoĻ,Ҫʵ˽ӿDecoderManager.IDecoderStatusListener,ʵֽܴɨ践ص
 * @author jan
 *
 */
public class BaseScanActivity extends Activity implements DecoderManager.IDecoderStatusListener{

    private static final String TAG = "BaseActivity";
    protected static final int DECODE_TIMEOUT = 2100;
    protected boolean isScanTimeOut = false;
    protected DecoderManager mDecoderMgr = null;
    protected boolean isOnResume = false;
    protected int scanCase = 0;
    private static final int OPENLIGHT = 1;
    private static final int CLOSELIGHT = 2;
    //ƹƵһHandler
    protected static LightControlHandler lightControlHandler = null;
    protected static int RETURN_CAMERA_CONN_ERR = 0x103;

    // how to control location light and flash light
    public class LightControlHandler extends Handler{
        public void handleMessage(android.os.Message msg) {
            Log.d(TAG, "lightControlHandler msg.what = " + msg.what + " mDecoderMgr = " + mDecoderMgr);
            if(mDecoderMgr != null){
                Log.d(TAG, "FlashMode = " + mDecoderMgr.getFlashMode());
            }
            //Ϊڷ Զ龳,ԶֶĿصƹв
            switch (msg.what) {
            case OPENLIGHT:
                if(mDecoderMgr != null){
                    mDecoderMgr.enableLight(Constants.LOCATION_LIGHT, true);
                    if(mDecoderMgr.getFlashMode() == Constants.FLASH_ALWAYS_ON_MODE ){
                        mDecoderMgr.enableLight(Constants.FLASH_LIGHT, true);
                        mDecoderMgr.enableLight(Constants.FLOOD_LIGHT, true); 
                    }
                }
                break;
            case CLOSELIGHT:
                if(mDecoderMgr != null){
                    mDecoderMgr.enableLight(Constants.LOCATION_LIGHT, false);
                    if(mDecoderMgr.getFlashMode() == Constants.FLASH_ALWAYS_ON_MODE ){
                        mDecoderMgr.enableLight(Constants.FLASH_LIGHT, false);
                        mDecoderMgr.enableLight(Constants.FLOOD_LIGHT, false);
                    }
                }
                break;

            default:
                break;
            }
        };
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        // TODO Auto-generated method stub
        Log.d(TAG, "onCreate ..");
        super.onCreate(savedInstanceState);
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        if(lightControlHandler == null){
            lightControlHandler = new LightControlHandler();
        }
        //mDecoderMgr.connectToDecoder();
        //1.DecoderManager
        mDecoderMgr = DecoderManager.getInstance();
    }

    @Override
    protected void onResume() {
        super.onResume();
        Log.d(TAG, "onResume this=" + this);
        isOnResume = true;
        scanCase = 0;
        //2.ɨ
//        int res = mDecoderMgr.connectToDecoder();
        int res = mDecoderMgr.connectDecoderSRV();
        
        if(res == RETURN_CAMERA_CONN_ERR){
            new AlertDialog.Builder(this)
            .setTitle(R.string.app_name)
            .setIcon(android.R.drawable.ic_dialog_info)
            .setMessage(R.string.scan_message)
            .setPositiveButton(R.string.dialog_ok, new OnClickListener() {
                @Override
                public void onClick(DialogInterface paramDialogInterface, int paramInt) {
                    closeSelf();
                }
            })
            .setCancelable(false)
            .show();
        }
        //3.ΪDecodermanagerһɨصӿ,ɨ践
        mDecoderMgr.addDecoderStatusListener(this);
//       lightControlHandler.removeMessages(CLOSELIGHT);
//      lightControlHandler.sendEmptyMessage(OPENLIGHT);
        mDecoderMgr.setDataTransferType(3);
    }

    @Override
    protected void onPause() {
    	Log.d(TAG, "onPause this=" + this);
    	super.onPause();
    	isOnResume = false;
     	// 4.App˵̨֮,бҪͷԴ,رջƳɨ
    	mDecoderMgr.removeDecoderStatusListener(this);
    	mDecoderMgr.stopDecode();
    	mDecoderMgr.disconnectDecoderSRV();
      }

    protected boolean isScanTimeOut(){
        return isScanTimeOut;
    }
  //ɼ̳ScanTestActivityѾʵ
    @Override
    public void onDecoderResultChanage(String result, String time) {
    }
    @Override
    public void onDecoderStatusChanage(int arg0) {
    }

    protected void closeSelf() {
        this.finish();
    }

	@Override
	protected void onDestroy() {
		mDecoderMgr = null;
		super.onDestroy();
		
	}
    
}
